unit WinImuSettingsUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, DateUtils;

type
  TWinImuSettings = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    EKF_Proc_Variance: TEdit;
    Label111: TLabel;
    EKF_Accel_Variance: TEdit;
    Label3: TLabel;
    EKF_Mag_Variance: TEdit;
    EKF_Accel_Gravity_Cut_Off: TEdit;
    Label4: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    procedure WaitForOk;
    { Private declarations }
  public
    { Public declarations }
    procedure LoadVariable(v: string);
  end;

var
  WinImuSettings: TWinImuSettings;

implementation

{$R *.dfm}

uses Main;

procedure TWinImuSettings.FormDestroy(Sender: TObject);
begin
 WinImuSettings:=nil;
end;

procedure TWinImuSettings.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TWinImuSettings.LoadVariable(v: string);
var
   i: integer;
   n: string;
begin
  i:= pos('=',v);
  if i>0 then begin
    n:=Copy(v,1,i-1);
    Delete(v,1,i);
  end;

  if LowerCase(n) = LowerCase('EKF_Proc_Variance') then EKF_Proc_Variance.Text:=v;
  if LowerCase(n) = LowerCase('EKF_Accel_Variance') then EKF_Accel_Variance.Text:=v;
  if LowerCase(n) = LowerCase('EKF_Mag_Variance') then EKF_Mag_Variance.Text:=v;
  if LowerCase(n) = LowerCase('EKF_Accel_Gravity_Cut_Off') then EKF_Accel_Gravity_Cut_Off.Text:=v;

end;

procedure TWinImuSettings.BitBtn1Click(Sender: TObject);
begin
  MainForm.AddToOutput('set EKF_Proc_Variance '+ EKF_Proc_Variance.Text+#13#10);
  MainForm.AddToOutput('set EKF_Accel_Variance '+ EKF_Accel_Variance.Text+#13#10);
  MainForm.AddToOutput('set EKF_Mag_Variance '+ EKF_Mag_Variance.Text+#13#10);
  MainForm.AddToOutput('set EKF_Accel_Gravity_Cut_Off '+ EKF_Accel_Gravity_Cut_Off.Text+#13#10);
  Close;
end;

procedure TWinImuSettings.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

procedure TWinImuSettings.FormCreate(Sender: TObject);
var
    s:string;
begin
  MainForm.ClearInput;
  MainForm.AddToOutput('cat imu'+#13#10);
  Application.ProcessMessages;
  while true do begin
    s:=MainForm.GetNextInputString;
    if s<>'' then begin
      if s='=>' then break;
      LoadVariable(s);
    end;
  end;

end;

procedure TWinImuSettings.SpeedButton2Click(Sender: TObject);
begin
    MainForm.AddToOutput('save ref'+#13#10);
end;

procedure TWinImuSettings.SpeedButton1Click(Sender: TObject);
begin
    MainForm.AddToOutput('reset imu'+#13#10);
    WaitForOk;
    FormCreate(Sender);
end;

procedure TWinImuSettings.WaitForOk;
var
   s: string;
   ts: TDateTime;
begin
   ts:=now;
      while true do begin
        if MilliSecondsBetween(Now,ts) > 1000 then break;
        Application.ProcessMessages;
        s:=MainForm.GetNextInputString;
        if s<>'' then begin
          if s='=>' then break;
        end;
      end;

end;


end.
