unit WinMonGyroUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons;

type
  TWinMonGyro = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    FileName: TEdit;
    SpeedButton1: TSpeedButton;
    Label3: TLabel;
    CheckBox1: TCheckBox;
    SaveDialog1: TSaveDialog;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Monitor: TMemo;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    F: TFileStream;
  end;

var
  WinMonGyro: TWinMonGyro;

implementation

uses MAIN;

{$R *.dfm}

procedure TWinMonGyro.FormCreate(Sender: TObject);
begin
//
end;

procedure TWinMonGyro.FormDestroy(Sender: TObject);
begin
  if Timer1.Enabled then begin
    MainForm.AddToOutput('mon off gyro'+#13#10);
    Timer1.Enabled:=false;
    if f<>nil then FreeAndNil(f);

  end;
  WinMonGyro:=nil;
end;

procedure TWinMonGyro.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TWinMonGyro.SpeedButton1Click(Sender: TObject);
begin
  if SaveDialog1.Execute then begin
     FileName.Text:=SaveDialog1.FileName;
  end;
end;

procedure TWinMonGyro.SpeedButton2Click(Sender: TObject);
begin
  if not CheckBox1.Checked then begin
    f:=nil;
    MainForm.AddToOutput('mon on gyro'+#13#10);
    Timer1.Enabled:=true;

  end else
  if Length(FileName.Text)>0 then begin
    if FileExists(FileName.Text) then
      f:= TFileStream.Create(FileName.Text, fmOpenReadWrite	 or fmShareDenyNone )
    else
      f:= TFileStream.Create(FileName.Text, fmCreate or fmShareDenyNone	 );

    f.Size:=0;

    MainForm.AddToOutput('mon on gyro'+#13#10);
    Timer1.Enabled:=true;

  end else ShowMessage('  ');
end;

procedure TWinMonGyro.SpeedButton3Click(Sender: TObject);
begin
  if f<>nil then FreeAndNil(f);
  MainForm.AddToOutput('mon off gyro'+#13#10);
  Timer1.Enabled:=false;
end;

procedure TWinMonGyro.Timer1Timer(Sender: TObject);
var
   s:string;
begin
  s:=MainForm.GYRO_mon;
  Monitor.Lines.Add(s);
  if f<>nil then begin
    s:=s+#13#10;
    f.Write(s[1],Length(s));
  end;
  while  Monitor.Lines.Count>2000 do Monitor.Lines.Delete(0);
end;

end.
